### Constructor

# Gio TlsCertificate new_from_file

since: 2.28

#### Declaration

    GTlsCertificate*
    g_tls_certificate_new_from_file (
      const gchar* file,
      GError** error
    )

#### Description

Creates a `GTlsCertificate` from the data in `file`.

As of 2.72, if the filename ends in `.p12` or `.pfx` the data is loaded by `g_tls_certificate_new_from_pkcs12()` otherwise it is loaded by g_tls_certificate_new_from_pem(). See those functions for exact details.

If `file` cannot be read or parsed, the function will return `NULL` and set `error`.

Available since: 2.28

#### Parameters

`file`

  Type: `const gchar*`

  File containing a certificate to import.

  The data is owned by the caller of the function.
  The value is a platform-native string, using the preferred OS encoding on Unix and UTF-8 on Windows.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the constructor if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GTlsCertificate`

The new certificate, or `NULL` on error.

The caller of the function takes ownership of the data, and is responsible for freeing it.